Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_lobster
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_lobster	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_lobster	(revision 2819)
@@ -98,8 +98,6 @@
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
-&namlobdia     !   additional 2D/3D tracers diagnostics ("key_trc_diaadd")
+&namlobdia     !   additional 2D/3D tracers diagnostics
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   nn_writedia =  360  !  time step frequency for tracers diagnostics
-!
 !              !    name   ! title of   ! units !
 !              !           ! the field  !       !  
@@ -130,9 +128,5 @@
 &namlobdbi     !   biological diagnostics trends     
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-!                !  3D bio diagnostics   units : mmole/m3/s   ("key_trc_diabio")
 !                !  2D bio diagnostics   units : mmole/m2/s   ("key_trdmld_trc")
-
-   nwritebio    =   4320    !  time step frequency for biological outputs
-!
 !                !  name    !       title of the field      !     units      !
    lobdiabio(1)  = 'NO3PHY' , 'Flux from NO3 to PHY          ',  'mmole/m3/s'
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_top
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_top	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_top	(revision 2819)
@@ -1,36 +1,50 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/TOP1 :  1 - tracer definition                     (namtrc    )
-!! namelists    2 - dynamical tracer trends               (namtrc_trd)
-!!              3 - tracer advection                      (namtrc_adv)
-!!              4 - tracer lateral diffusion              (namtrc_ldf)
-!!              5 - tracer vertical physics               (namtrc_zdf)
-!!              6 - tracer newtonian damping              (namtrc_dmp)
+!! NEMO/TOP2 namelits :  1 - tracer definition                     (namtrc    )
+!!                       2 - tracer advection                      (namtrc_adv)
+!!                       3 - tracer lateral diffusion              (namtrc_ldf)
+!!                       4 - tracer vertical physics               (namtrc_zdf)
+!!                       5 - tracer newtonian damping              (namtrc_dmp)
+!!                       6 - dynamical tracer trends               (namtrc_trd)
+!!                       7 - tracer output                         (namtrc_wri)
 !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 &namtrc     !   tracers definition
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+!
    nn_dttrc      =  1        !  time step frequency for passive sn_tracers
-   nn_writetrc   =  360      !  time step frequency for sn_tracer outputs
+   nn_writetrc   =  60      !  time step frequency for sn_tracer outputs
    ln_rsttr      = .false.   !  start from a restart file (T) or not (F)
-   nn_rsttr      =   0       !  restart control = 0 initial time step is not compared to the restart file value
+   nn_rsttr      =   1       !  restart control = 0 initial time step is not compared to the restart file value
                            !                  = 1 do not use the value in the restart file
                            !                  = 2 calendar parameters read in the restart file
-   cn_trcrst_in  = "restart_trc"   !  suffix of pass. sn_tracer restart name (input)
+   cn_trcrst_in  = "restart_trc.nc"   !  suffix of pass. sn_tracer restart name (input)
    cn_trcrst_out = "restart_trc"   !  suffix of pass. sn_tracer restart name (output)
+   ln_trcdta     =   .false.    !  Initialisation from data input file (T) or not (F)
 !
-!              ! name  !     title of the field       !   units       ! initial data ! save   !
-!              !       !                              !               ! from file    ! or not ! 
-!              !       !                              !               ! or not       !        !
-   sn_tracer(1)   = 'DET' , 'Detritus                   ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(2)   = 'ZOO' , 'Zooplankton concentration  ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(3)   = 'PHY' , 'Phytoplankton concentration',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(4)   = 'NO3' , 'Nitrate concentration      ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(5)   = 'NH4' , 'Ammonium concentration     ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(6)   = 'DOM' , 'Dissolved organic matter   ',  'mmole-N/m3' ,  .false.     ,  .true.
+!                ! name  !     title of the field          !   units       ! initial data ! save   !
+!                !       !                                 !               ! from file    ! or not ! 
+!                !       !                                 !               ! or not       !        !
+   sn_tracer(1)   = 'DET'   , 'Detritus                   ',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(2)   = 'ZOO'   , 'Zooplankton concentration  ',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(3)   = 'PHY'   , 'Phytoplankton concentration',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(4)   = 'NO3'   , 'Nitrate concentration      ',  'mmole-N/m3' ,  .false.     ,  .true.
+   sn_tracer(5)   = 'NH4'   , 'Ammonium concentration     ',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(6)   = 'DOM'   , 'Dissolved organic matter   ',  'mmole-N/m3' ,  .false.     ,  .false.
 /
 !-----------------------------------------------------------------------
-&namtrc_adv    !   advection scheme for passive tracer
+&namtrc_dta      !    Initialisation from data input file (T) or not (F)
 !-----------------------------------------------------------------------
-   ln_trcadv_cen2   =  .false.  !  2nd order centered scheme
+!
+!                !  file name  ! frequency (hours) ! variable   ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
+!                !             !  (if <0  months)  !   name     !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
+   sn_trcdta(4)  = 'NO3_R1'    ,        -12        ,  'NO3'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+
+   cn_dir        =     './'    !  root directory for the location of the runoff files
+   rn_trfac(4)   =    1.0      !   -       -       -       -      -
+/
+!-----------------------------------------------------------------------
+&namtrc_adv    !   advection scheme for passive tracer 
+!-----------------------------------------------------------------------
+   ln_trcadv_cen2   =  .false.  !  2nd order centered scheme   
    ln_trcadv_tvd    =  .true.   !  TVD scheme
    ln_trcadv_muscl  =  .false.  !  MUSCL scheme
@@ -51,4 +65,5 @@
    ln_trcldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
 !                               !  Coefficient
+   rn_ahtrc_0       =  1000.    !  horizontal eddy diffusivity for tracers [m2/s]
    rn_ahtrb_0       =     0.    !     background eddy diffusivity for ldf_iso [m2/s]
 /
@@ -60,11 +75,12 @@
 /
 !-----------------------------------------------------------------------
-&namtrc_rad        !  treatment of negative concentrations
+&namtrc_rad        !  treatment of negative concentrations 
 !-----------------------------------------------------------------------
    ln_trcrad   =  .false.  !  artificially correct negative concentrations (T) or not (F)
 /
 !-----------------------------------------------------------------------
-&namtrc_dmp    !   passive tracer newtonian damping    ('key_tradmp && key_trcdmp')
+&namtrc_dmp    !   passive tracer newtonian damping  
 !-----------------------------------------------------------------------
+   ln_trcdmp   =  .false.  !  add a damping termn (T) or not (F)
    nn_hdmp_tr  =   -1      !  horizontal shape =-1, damping in Med and Red Seas only
                            !                   =XX, damping poleward of XX degrees (XX>0)
@@ -79,17 +95,18 @@
 /
 !-----------------------------------------------------------------------
-&namtrc_trd       !   diagnostics on tracer trends        ('key_trdtrc')
-!                          or mixed-layer trends          ('key_trdmld_trc')
+&namtrc_trd                !   diagnostics on tracer trends        ('key_trdtrc')
+!                                   or mixed-layer trends          ('key_trdmld_trc')
 !----------------------------------------------------------------------
-   nn_trd_trc   =  360      !  time step frequency and tracers trends
-   nn_ctls_trc  =   0       !  control surface type in mixed-layer trends (0,1 or n<jpk)
-   rn_ucf_trc   =  86400    !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
+   nn_trd_trc  =  5475      !  time step frequency and tracers trends
+   nn_ctls_trc =   0        !  control surface type in mixed-layer trends (0,1 or n<jpk)
+   rn_ucf_trc  =   1        !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
    ln_trdmld_trc_restart = .false.  !  restart for ML diagnostics
-   ln_trdmld_trc_instant = .false.  !  flag to diagnose trends of instantantaneous or mean ML T/S
+   ln_trdmld_trc_instant = .true.  !  flag to diagnose trends of instantantaneous or mean ML T/S
    ln_trdtrc(1)  =   .true.
-   ln_trdtrc(2)  =   .true.
-   ln_trdtrc(3)  =   .true.
-   ln_trdtrc(4)  =   .true.
-   ln_trdtrc(5)  =   .true.
-   ln_trdtrc(6)  =   .true.
 /
+!-----------------------------------------------------------------------
+&namtrc_dia       !   parameters for passive tracer additional diagnostics
+!----------------------------------------------------------------------
+   ln_diatrc     =  .true.   !  save additional diag. (T) or not (F)
+   nn_writedia   =  60     !  time step frequency for diagnostics
+/
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 2819)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_zdftmx key_iomput 
+ bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_zdftke key_zdfddm key_zdftmx key_iomput 
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_pisces
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_pisces	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_pisces	(revision 2819)
@@ -142,6 +142,4 @@
 &nampisdia     !   additional 2D/3D tracers diagnostics ("key_trc_diaadd")
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   nn_writedia  =  5475   !  time step frequency for tracers diagnostics
-!
 !              !    name   !           title of the field          !     units      !
 !              !           !                                       !                !  
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_top
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_top	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_top	(revision 2819)
@@ -1,9 +1,11 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !! NEMO/TOP1 :  1 - tracer definition                     (namtrc    )
-!! namelists    2 - dynamical tracer trends               (namtrc_trd)
+!!              2 - tracer data initialisation            (namtrc_dta)
 !!              3 - tracer advection                      (namtrc_adv)
 !!              4 - tracer lateral diffusion              (namtrc_ldf)
 !!              5 - tracer vertical physics               (namtrc_zdf)
 !!              6 - tracer newtonian damping              (namtrc_dmp)
+!!              7 - dynamical tracer trends               (namtrc_trd)
+!!              8 - tracer output diagonstics             (namtrc_dia)
 !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -18,4 +20,5 @@
    cn_trcrst_in  = "restart_trc"   !  suffix of pass. sn_tracer restart name (input)
    cn_trcrst_out = "restart_trc"   !  suffix of pass. sn_tracer restart name (output)
+   ln_trcdta     =   .true. !  Initialisation from data input file (T) or not (F)
 !
 !              !    name   !           title of the field              !   units    ! initial data ! save   !
@@ -48,4 +51,29 @@
 /
 !-----------------------------------------------------------------------
+&namtrc_dta      !    Initialisation from data input file
+!-----------------------------------------------------------------------
+!
+!                !  file name               ! frequency (hours) ! variable   ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
+!                !                          !  (if <0  months)  !   name     !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
+   sn_trcdta(1)  = 'data_DIC_nomask'        ,        -12        ,  'DIC'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(2)  = 'data_Alkalini_nomask'   ,        -12        ,  'Alkalini',    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(3)  = 'data_O2_nomask'         ,        -1         ,  'O2'      ,    .true.    , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(5)  = 'data_PO4_nomask'        ,        -1         ,  'PO4'     ,    .true.    , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(7)  = 'data_Si_nomask'         ,        -1         ,  'Si'      ,    .true.    , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(10) = 'data_DOC_nomask'        ,        -12        ,  'DOC'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(14) = 'data_Fer_nomask'        ,        -12        ,  'Fer'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(23) = 'data_NO3_nomask'        ,        -1         ,  'NO3'     ,    .true.    , .true. , 'yearly'  , ''       , ''
+!
+   cn_dir        =  './'      !  root directory for the location of the data files
+   rn_trfac(1)   =   1.0e-06  !  multiplicative factor
+   rn_trfac(2)   =   1.0e-06  !  -      -      -     -
+   rn_trfac(3)   =  44.6e-06  !  -      -      -     -
+   rn_trfac(5)   = 122.0e-06  !  -      -      -     -
+   rn_trfac(7)   =   1.0e-06  !  -      -      -     -
+   rn_trfac(10)  =   1.0      !  -      -      -     -
+   rn_trfac(14)  =   1.0      !  -      -      -     -
+   rn_trfac(23)  =   7.6e-06  !  -      -      -     -
+/
+!-----------------------------------------------------------------------
 &namtrc_adv    !   advection scheme for passive tracer 
 !-----------------------------------------------------------------------
@@ -69,4 +97,5 @@
    ln_trcldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
 !                               !  Coefficient
+   rn_ahtrc_0       =  2000.    !  horizontal eddy diffusivity for tracers [m2/s]
    rn_ahtrb_0       =     0.    !     background eddy diffusivity for ldf_iso [m2/s]
 /
@@ -83,6 +112,7 @@
 /
 !-----------------------------------------------------------------------
-&namtrc_dmp    !   passive tracer newtonian damping    ('key_tradmp && key_trcdmp')
+&namtrc_dmp    !   passive tracer newtonian damping   
 !-----------------------------------------------------------------------
+   ln_trcdmp   =  .false.  !  add a damping termn (T) or not (F)
    nn_hdmp_tr  =   -1      !  horizontal shape =-1, damping in Med and Red Seas only
                            !                   =XX, damping poleward of XX degrees (XX>0)
@@ -107,25 +137,10 @@
    ln_trdtrc(1)  =   .true.
    ln_trdtrc(2)  =   .true.
-   ln_trdtrc(3)  =   .false.
-   ln_trdtrc(4)  =   .false.
-   ln_trdtrc(5)  =   .false.
-   ln_trdtrc(6)  =   .false.
-   ln_trdtrc(7)  =   .false.
-   ln_trdtrc(8)  =   .false.
-   ln_trdtrc(9)  =   .false.
-   ln_trdtrc(10) =   .false.
-   ln_trdtrc(11) =   .false.
-   ln_trdtrc(12) =   .false.
-   ln_trdtrc(13) =   .false.
-   ln_trdtrc(14) =   .false.
-   ln_trdtrc(15) =   .false.
-   ln_trdtrc(16) =   .false.
-   ln_trdtrc(17) =   .false.
-   ln_trdtrc(18) =   .false.
-   ln_trdtrc(19) =   .false.
-   ln_trdtrc(20) =   .false.
-   ln_trdtrc(21) =   .false.
-   ln_trdtrc(22) =   .false.
    ln_trdtrc(23) =   .true.
-   ln_trdtrc(24) =   .false.
 /
+!-----------------------------------------------------------------------
+&namtrc_dia       !   parameters for passive tracer additional diagnostics
+!----------------------------------------------------------------------
+   ln_diatrc     =  .true.   !  save additional diag. (T) or not (F)
+   nn_writedia   =  5475     !  time step frequency for diagnostics
+/
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/cpp_ORCA2_LIM_PISCES.fcm
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/cpp_ORCA2_LIM_PISCES.fcm	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/cpp_ORCA2_LIM_PISCES.fcm	(revision 2819)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_zdftke key_zdfddm key_top key_pisces key_dtatrc key_diatrc key_iomput 
+bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_zdfddm key_top key_pisces key_iomput 
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist_top
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist_top	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist_top	(revision 2819)
@@ -1,9 +1,11 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !! NEMO/TOP1 :  1 - tracer definition                     (namtrc    )
-!! namelists    2 - dynamical tracer trends               (namtrc_trd)
+!!              2 - tracer data initialisation            (namtrc_dta)
 !!              3 - tracer advection                      (namtrc_adv)
 !!              4 - tracer lateral diffusion              (namtrc_ldf)
 !!              5 - tracer vertical physics               (namtrc_zdf)
 !!              6 - tracer newtonian damping              (namtrc_dmp)
+!!              7 - dynamical tracer trends               (namtrc_trd)
+!!              8 - tracer output diagonstics             (namtrc_dia)
 !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -18,4 +20,5 @@
    cn_trcrst_in  = "restart_trc"   !  suffix of pass. sn_tracer restart name (input)
    cn_trcrst_out = "restart_trc"   !  suffix of pass. sn_tracer restart name (output)
+   ln_trcdta     =   .true. !  Initialisation from data input file (T) or not (F)
 !
 !              !    name   !           title of the field              !   units    ! initial data ! save   !
@@ -48,4 +51,29 @@
 /
 !-----------------------------------------------------------------------
+&namtrc_dta      !    Initialisation from data input file
+!-----------------------------------------------------------------------
+!
+!                !  file name               ! frequency (hours) ! variable   ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
+!                !                          !  (if <0  months)  !   name     !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
+   sn_trcdta(1)  = 'data_DIC_nomask'        ,        -12        ,  'DIC'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(2)  = 'data_Alkalini_nomask'   ,        -12        ,  'Alkalini',    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(3)  = 'data_O2_nomask'         ,        -1         ,  'O2'      ,    .true.    , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(5)  = 'data_PO4_nomask'        ,        -1         ,  'PO4'     ,    .true.    , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(7)  = 'data_Si_nomask'         ,        -1         ,  'Si'      ,    .true.    , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(10) = 'data_DOC_nomask'        ,        -12        ,  'DOC'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(14) = 'data_Fer_nomask'        ,        -12        ,  'Fer'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+   sn_trcdta(23) = 'data_NO3_nomask'        ,        -1         ,  'NO3'     ,    .true.    , .true. , 'yearly'  , ''       , ''
+!
+   cn_dir        =  './'      !  root directory for the location of the data files
+   rn_trfac(1)   =   1.0e-06  !  multiplicative factor
+   rn_trfac(2)   =   1.0e-06  !  -      -      -     -
+   rn_trfac(3)   =  44.6e-06  !  -      -      -     -
+   rn_trfac(5)   = 122.0e-06  !  -      -      -     -
+   rn_trfac(7)   =   1.0e-06  !  -      -      -     -
+   rn_trfac(10)  =   1.0      !  -      -      -     -
+   rn_trfac(14)  =   1.0      !  -      -      -     -
+   rn_trfac(23)  =   7.6e-06  !  -      -      -     -
+/
+!-----------------------------------------------------------------------
 &namtrc_adv    !   advection scheme for passive tracer 
 !-----------------------------------------------------------------------
@@ -69,4 +97,5 @@
    ln_trcldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
 !                               !  Coefficient
+   rn_ahtrc_0       =  2000.    !  horizontal eddy diffusivity for tracers [m2/s]
    rn_ahtrb_0       =     0.    !     background eddy diffusivity for ldf_iso [m2/s]
 /
@@ -83,6 +112,7 @@
 /
 !-----------------------------------------------------------------------
-&namtrc_dmp    !   passive tracer newtonian damping    ('key_tradmp && key_trcdmp')
+&namtrc_dmp    !   passive tracer newtonian damping   
 !-----------------------------------------------------------------------
+   ln_trcdmp   =  .false.  !  add a damping termn (T) or not (F)
    nn_hdmp_tr  =   -1      !  horizontal shape =-1, damping in Med and Red Seas only
                            !                   =XX, damping poleward of XX degrees (XX>0)
@@ -107,25 +137,10 @@
    ln_trdtrc(1)  =   .true.
    ln_trdtrc(2)  =   .true.
-   ln_trdtrc(3)  =   .false.
-   ln_trdtrc(4)  =   .false.
-   ln_trdtrc(5)  =   .false.
-   ln_trdtrc(6)  =   .false.
-   ln_trdtrc(7)  =   .false.
-   ln_trdtrc(8)  =   .false.
-   ln_trdtrc(9)  =   .false.
-   ln_trdtrc(10) =   .false.
-   ln_trdtrc(11) =   .false.
-   ln_trdtrc(12) =   .false.
-   ln_trdtrc(13) =   .false.
-   ln_trdtrc(14) =   .false.
-   ln_trdtrc(15) =   .false.
-   ln_trdtrc(16) =   .false.
-   ln_trdtrc(17) =   .false.
-   ln_trdtrc(18) =   .false.
-   ln_trdtrc(19) =   .false.
-   ln_trdtrc(20) =   .false.
-   ln_trdtrc(21) =   .false.
-   ln_trdtrc(22) =   .false.
    ln_trdtrc(23) =   .true.
-   ln_trdtrc(24) =   .false.
 /
+!-----------------------------------------------------------------------
+&namtrc_dia       !   parameters for passive tracer additional diagnostics
+!----------------------------------------------------------------------
+   ln_diatrc     =  .true.   !  save additional diag. (T) or not (F)
+   nn_writedia   =  1460     !  time step frequency for diagnostics
+/
Index: branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm
===================================================================
--- branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm	(revision 2789)
+++ branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm	(revision 2819)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_ldfslp key_traldf_c2d key_traldf_eiv key_top key_offline key_pisces key_dtatrc key_diatrc key_iomput 
+bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_ldfslp key_traldf_c2d key_traldf_eiv key_top key_offline key_pisces key_iomput 