Index: /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml
===================================================================
--- /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 2841)
+++ /branches/2011/dev_r2802_MERCATOR9_floats/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 2842)
@@ -206,7 +206,8 @@
       </group>
 
+
       <!-- variables available with key_float -->
       <group id="floatvar" axis_ref="nfloat" grid_ref="scalarpoint" zoom_ref="1point">
-        <field id="traj_lon"   description="floats longitude"   unit="deg"   />
+        <field id="traj_lon"   description="floats longitude"   unit="deg"  operation="inst(X)" />
         <field id="traj_lat"   description="floats latitude"    unit="deg"   />
         <field id="traj_dep"   description="floats depth"       unit="m"     />
@@ -218,5 +219,5 @@
 
     </field_definition>
-    
+
     <!-- 
 ============================================================================================================
@@ -275,4 +276,15 @@
 	</group>
 
+        <!-- variables available with key_float, instantaneous fields -->
+        <file id="floats"  description="floats variables">
+            <field ref="traj_lon"   name="floats_longitude"   freq_op="86400" />
+            <field ref="traj_lat"   name="floats_latitude"    freq_op="86400" />
+            <field ref="traj_dep"   name="floats_depth"       freq_op="86400" />
+            <field ref="traj_temp"  name="floats_temperature" freq_op="86400" />
+            <field ref="traj_salt"  name="floats_salinity"    freq_op="86400" />
+            <field ref="traj_dens"  name="floats_density"     freq_op="86400" />
+            <field ref="traj_group" name="floats_group"       freq_op="86400" />
+        </file>
+
       </group>
       
@@ -395,8 +407,9 @@
     
     <axis_definition>  
-      <axis id="deptht" description="Vertical T levels" unit="m" positive=".false." />
-      <axis id="depthu" description="Vertical U levels" unit="m" positive=".false." />
-      <axis id="depthv" description="Vertical V levels" unit="m" positive=".false." />
-      <axis id="depthw" description="Vertical W levels" unit="m" positive=".false." />
+      <axis id="deptht" description="Vertical T levels" unit="m"       positive=".false." />
+      <axis id="depthu" description="Vertical U levels" unit="m"       positive=".false." />
+      <axis id="depthv" description="Vertical V levels" unit="m"       positive=".false." />
+      <axis id="depthw" description="Vertical W levels" unit="m"       positive=".false." />
+      <axis id="nfloat" description="Number of float"   unit="no unit" positive=".false." />
       <axis id="none" description="axe non defini" unit="none" size="1" />
     </axis_definition> 
@@ -838,13 +851,5 @@
 	</group>
 
-        <file id="floats"  description="floats variables">
-           <field ref="traj_lon"   name="floats_longitude"   operation="inst(X)"    />
-           <field ref="traj_lat"   name="floats_latitude"    operation="inst(X)"    />
-           <field ref="traj_dep"   name="floats_depth"       operation="inst(X)"    />
-           <field ref="traj_temp"  name="floats_temperature" operation="inst(X)"    />
-           <field ref="traj_salt"  name="floats_salinity"    operation="inst(X)"    />
-           <field ref="traj_dens"  name="floats_density"     operation="inst(X)"    />
-           <field ref="traj_group" name="floats_group"       operation="inst(X)"    />
-        </file>
+      </group>
       
       <group id="3d" output_freq="259200" output_level="10" enabled=".TRUE.">                      <!-- 3d files -->
@@ -967,9 +972,8 @@
     
     <axis_definition>  
-      <axis id="deptht" description="Vertical T levels" unit="m"    positive=".false." />
-      <axis id="depthu" description="Vertical U levels" unit="m"    positive=".false." />
-      <axis id="depthv" description="Vertical V levels" unit="m"    positive=".false." />
-      <axis id="depthw" description="Vertical W levels" unit="m"    positive=".false." />
-      <axis id="nfloat" description="number of float"   unit="none" positive=".false."  />
+      <axis id="deptht" description="Vertical T levels" unit="m" positive=".false." />
+      <axis id="depthu" description="Vertical U levels" unit="m" positive=".false." />
+      <axis id="depthv" description="Vertical V levels" unit="m" positive=".false." />
+      <axis id="depthw" description="Vertical W levels" unit="m" positive=".false." />
       <axis id="none" description="axe non defini" unit="none" size="1" />
     </axis_definition> 